
        bank1

        movlw B'10011111'
        movwf OPTION_REG	        ;high resistors off

        movlw B'11111010'
        movwf TRISA			;port A<0,2> - output
                                                ;port A1 - input

        movlw B'01111011'
        movwf OSCCON		        ;tuning generator 16MHz

        movlw 0x3f
        movwf OSCTUNE                  ;set frequency

        movlw B'00000000'
        movwf T1CON                     ;TMR1 stop

        movlw B'00000000'
        movwf T2CON                     ;TMR2 stop

        bank0
        clrf INTCON			       ;dont interrupt
        nop
        bsf INTCON,IOCIE
        nop
        bsf INTCON,0
        nop
        bsf INTCON,6

        bank1
        bsf PIE1,RCIE

        movlw 0x80
        movwf duration2		         ;set start duration impulse 2

        bank2
        movlw B'00000000'
        movwf APFCON		         ;alternate input USART

        bank6
        clrf SLRCONA

        bank7
        movlw B'00000010'
        movwf INLVLA

        movlw B'00000010'
        movwf IOCAF
        movwf IOCAN
        movwf IOCAP
;**********End section start init

;***** Init RS-232 (16MHz)

        _bank_3
        movlw 0x00
        movwf SPBRGH
	movlw 0x67
	movwf SPBRGL                         ;speed usart - 9615
        bcf BAUDCON,BRG16                 ;8 bit BRG
        bsf TXSTA,BRGH		            ;high speed mode

        movlw B'00000000'
        movwf ANSELA

        bcf TXSTA,SYNC		           ;asynchronous mode
        bsf RCSTA,SPEN		           ;turn on USART

        _bank_1
        bsf PIE1,RCIE                         ;interrupt from receiver UART

        _bank_3
        bcf RCSTA,RX9		          ;8 bit

        bsf RCSTA,CREN		          ;enable receiver
;*****End section tuning RS-232

;**********Init section PWM
	_bank_27

        movlw B'01100000'                ;divided 64, takt=Fosc (16MHz)
        movwf PWM2CLKCON

        movlw B'00000010'                ;enable PWM2
        movwf PWMEN

        movlw B'00000010'                ;enable pin PWM2
        movwf PWMOUT

        movlw B'11100000'                ;standart mode
        movwf PWM2CON

        movlw B'10000000'
        movwf PWM2LDCON              ;reload enable

        clrf PWM2PHH                      ;fhase 0
        clrf PWM2PHL

        clrf PWM2OFH                      ;offset 0
        clrf PWM2OFL

        movlw 0x00
        movwf PWM2PRH
        movlw 0xfd
        movwf PWM2PRL                 ;period 1kHz

        movlw 0x00
        movwf PWM2DCH
        movf duration2,W
        movwf PWM2DCL                 ;8 bit resolution duty cycle
;**********End section init PWM

;Test code
;RX 232

_test_232
        _bank_3
        bsf RCSTA,CREN		        ;enable receiver
        nop
        movlb 0x00
_test_232_1
	btfss PIR1,RCIF
	goto _test_232_1	                ;wait byte
        nop
	_bank_3
        bcf RCSTA,CREN		        ;disable receiver
	movf RCREG,W		        ;
        movwf duration2		        ; reseiver byte PWM2

        ;movlw 0x30
        ;movwf duration2

        _bank_27
        movlw 0x00
        movwf PWM2DCH
        movf duration2,W
        movwf PWM2DCL                ;8 bit resolution duty cycle

        goto _test_232

	end
